function createMenu()

	local MenuBackcolor = Turbine.UI.Color(0.6, 0.0, 0.0, 0.0);

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();

	local menuMaxHeight = (screenHeight / 3);
	local menuCurHeight = 0;
	local menuCurTop = 3;

	local i = 1;
	local mCounter = 1;
	local lineHeight = 25; -- Height of each line in the menu.
	local iconSize = 15;
	local linebuffer = 3;
	local menuWidth = 340;

	local numOfSlots = 6; -- Each menu item will always have six slots but only display the req'd icons

	local thumbLeft = 1;
	local icon1Left = thumbLeft + 6;
	local icon2Left = icon1Left + iconSize + 2;
	local icon3Left = icon2Left + iconSize + 2;
	local icon4Left = icon3Left + iconSize + 2;
	local icon5Left = icon4Left + iconSize + 2;
	local icon6Left = icon5Left + iconSize + 2;
	local labelLeft = 0;

	labelLeft = icon6Left + iconSize + 6;

-- Windows, controls, scrollbars and buttons

	-- Create tooltip window.
	cjTTip = Turbine.UI.Lotro.Window();
	cjTTip:SetPosition(((screenWidth / 2) - 200 ), ((screenHeight / 2) - 100 ));
	cjTTip:SetText();
	cjTTip:SetSize(400, 200);
	cjTTip:SetVisible(false);

	-- Create text for tooltip.
	cjTTText1 = Turbine.UI.Lotro.TextBox();
	cjTTText1:SetParent(cjTTip);
	cjTTText1:SetPosition(20, 30);
	cjTTText1:SetSize(360, 20);
	cjTTText1:SetMultiline(false);
	cjTTText1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	cjTTText1:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	cjTTText1:SetForeColor(Turbine.UI.Color(1.0, 0.0, 0.0));
	cjTTText1:SetVisible(true);
	cjTTText1:SetBackColorBlendMode(8);

	cjTTText2 = Turbine.UI.Lotro.TextBox();
	cjTTText2:SetParent(cjTTip);
	cjTTText2:SetPosition(20, 50);
	cjTTText2:SetSize(360, 20);
	cjTTText2:SetMultiline(false);
	cjTTText2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	cjTTText2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	cjTTText2:SetForeColor(Turbine.UI.Color(1.0, 1.0, 0.0));
	cjTTText2:SetVisible(true);
	cjTTText2:SetBackColorBlendMode(8);

	cjTTText3 = Turbine.UI.Lotro.TextBox();
	cjTTText3:SetParent(cjTTip);
	cjTTText3:SetPosition(20, 70);
	cjTTText3:SetSize(360, 20);
	cjTTText3:SetMultiline(false);
	cjTTText3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	cjTTText3:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	cjTTText3:SetForeColor(Turbine.UI.Color(0.0, 1.0, 0.0));
	cjTTText3:SetVisible(true);
	cjTTText3:SetBackColorBlendMode(8);

	cjTTText4 = Turbine.UI.Lotro.TextBox();
	cjTTText4:SetParent(cjTTip);
	cjTTText4:SetPosition(20, 90);
	cjTTText4:SetSize(360, 20);
	cjTTText4:SetMultiline(false);
	cjTTText4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	cjTTText4:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	cjTTText4:SetForeColor(Turbine.UI.Color(0.0, 0.0, 1.0));
	cjTTText4:SetVisible(true);
	cjTTText4:SetBackColorBlendMode(8);

	cjTTText5 = Turbine.UI.Lotro.TextBox();
	cjTTText5:SetParent(cjTTip);
	cjTTText5:SetPosition(20, 110);
	cjTTText5:SetSize(360, 70);
	cjTTText5:SetMultiline(true);
	cjTTText5:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	cjTTText5:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	cjTTText5:SetForeColor(Turbine.UI.Color(1.0, 1.0, 1.0));
	cjTTText5:SetVisible(true);
	cjTTText5:SetBackColorBlendMode(8);

	cjMenuParent = Turbine.UI.Window();
	cjMenuParent:SetBackColor(MenuBackcolor);
	cjMenuParent:SetMouseVisible(true);
	cjMenuParent:SetOpacity(0);
	cjMenuParent:SetPosition(0,0);
	cjMenuParent:SetSize(screenWidth,screenHeight);
	cjMenuParent:SetVisible(false);
	cjMenuParent:SetZOrder(198);

	cjMenuBody = Turbine.UI.Window();
	cjMenuBody:SetParent(cjMenuParent);
	cjMenuBody:SetBackColor(MenuBackcolor);
	cjMenuBody:SetMouseVisible(true);
	cjMenuBody:SetOpacity(0.8);
	cjMenuBody:SetVisible(true);
	cjMenuBody:SetWidth(menuWidth);
	cjMenuBody:SetZOrder(199);

	cjMenuHolder = Turbine.UI.Control();
	cjMenuHolder:SetParent(cjMenuBody);
	cjMenuHolder:SetBackColor(MenuBackcolor);
	cjMenuHolder:SetMouseVisible(true);
	cjMenuHolder:SetOpacity(0);
	cjMenuHolder:SetVisible(true);
	cjMenuHolder:SetWidth(menuWidth);
	cjMenuHolder:SetZOrder(200);

	scrollBar = Turbine.UI.ScrollBar();
	scrollBar:SetParent(cjMenuBody);
	scrollBar:SetTop(0);
	scrollBar:SetZOrder(201);
	scrollBar:SetMinimum(0);
	scrollBar:SetWidth(15);
	scrollBar:SetValue(0);
	scrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);

-- This is retained from Galuhad's WardenTrainerLite because it works perfectly well
	scrollIncBut = Turbine.UI.Button();
	scrollIncBut:SetSize(15,15);
	scrollIncBut:SetBackground("TempleDog/CJTome/UI/scrollbar_inc_up.tga");

	scrollDecBut = Turbine.UI.Button();
	scrollDecBut:SetSize(15,15);
	scrollDecBut:SetBackground("TempleDog/CJTome/UI/scrollbar_dec_up.tga");

	scrollThumb = Turbine.UI.Control();
	scrollThumb:SetSize(15,15);
	scrollThumb:SetBackground("TempleDog/CJTome/UI/scrollbar_thumb.tga");

	scrollBar:SetDecrementButton(scrollDecBut);
	scrollBar:SetIncrementButton(scrollIncBut);
	scrollBar:SetThumbButton(scrollThumb);

	cjMenuItem = {};
	cjMenuLabel = {};
	cjMenuIcon1 = {};
	cjMenuIcon2 = {};
	cjMenuIcon3 = {};
	cjMenuIcon4 = {};
	cjMenuIcon5 = {};
	cjMenuIcon6 = {};

-- Creates the menu based on the filter setting in user data file.
	ShortList = WhichChecked;
	while i <= NumCJs do -- Runs through all the CJs in the table.

		local cjThumbDir = "TempleDog/CJTome/Resources/";
		local cjLevel = cjSets[i].Filter;

-- Only display a CJ in the menu if its corresponding level is equal to or greater than the level selected.		
		if cjLevel >= ShortList then

		local gName = cjSets[i].Name;
		local gTip1 = cjSets[i].Tip1;
		local gTip2 = cjSets[i].Tip2;
		local gTip3 = cjSets[i].Tip3;
		local gTip4 = cjSets[i].Tip4;
		local gTip5 = cjSets[i].Tip5;
		local cjCol = {};
		cjCol[1] = cjIcons[cjSets[i].Colours[1]].small;
		cjCol[2] = cjIcons[cjSets[i].Colours[2]].small;
		cjCol[3] = cjIcons[cjSets[i].Colours[3]].small;
		cjCol[4] = cjIcons[cjSets[i].Colours[4]].small;
		cjCol[5] = cjIcons[cjSets[i].Colours[5]].small;
		cjCol[6] = cjIcons[cjSets[i].Colours[6]].small;

		cjMenuItem[mCounter] = Turbine.UI.Control();
		cjMenuItem[mCounter]:SetHeight(lineHeight);
		cjMenuItem[mCounter]:SetLeft(linebuffer);
		cjMenuItem[mCounter]:SetTop(menuCurTop);
		cjMenuItem[mCounter]:SetWidth(menuWidth - (2 * linebuffer));
		cjMenuItem[mCounter]:SetBackColor(Turbine.UI.Color(0.6, 0.3, 0.3, 0.2));
		cjMenuItem[mCounter]:SetOpacity(1);
		cjMenuItem[mCounter]:SetMouseVisible(true);
		cjMenuItem[mCounter]:SetParent(cjMenuHolder);

		if cjCol[1] ~= "Blank.tga" then
			cjMenuIcon1[mCounter] = Turbine.UI.Control();
			cjMenuIcon1[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon1[mCounter]:SetHeight(iconSize);
			cjMenuIcon1[mCounter]:SetWidth(iconSize);
			cjMenuIcon1[mCounter]:SetLeft(icon1Left);
			cjMenuIcon1[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			-- cjMenuIcon1[mCounter]:SetBackColor(Turbine.UI.Color(0.6, 0.0, 0.0, 0.2));
			cjMenuIcon1[mCounter]:SetBackground(cjThumbDir .. cjCol[1]);
			-- cjMenuIcon1[mCounter]:SetBackColorBlendMode(4);
			cjMenuIcon1[mCounter]:SetMouseVisible(false);
		end

		if cjCol[2] ~= "Blank.tga" then
			cjMenuIcon2[mCounter] = Turbine.UI.Control();
			cjMenuIcon2[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon2[mCounter]:SetHeight(iconSize);
			cjMenuIcon2[mCounter]:SetWidth(iconSize);
			cjMenuIcon2[mCounter]:SetLeft(icon2Left);
			cjMenuIcon2[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			cjMenuIcon2[mCounter]:SetBackground(cjThumbDir .. cjCol[2]);
			cjMenuIcon2[mCounter]:SetMouseVisible(false);
		end

		if cjCol[3] ~= "Blank.tga" then
			cjMenuIcon3[mCounter] = Turbine.UI.Control();
			cjMenuIcon3[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon3[mCounter]:SetHeight(iconSize);
			cjMenuIcon3[mCounter]:SetWidth(iconSize);
			cjMenuIcon3[mCounter]:SetLeft(icon3Left);
			cjMenuIcon3[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			cjMenuIcon3[mCounter]:SetBackground(cjThumbDir .. cjCol[3]);
			cjMenuIcon3[mCounter]:SetMouseVisible(false);
		end

		if cjCol[4] ~= "Blank.tga" then
			cjMenuIcon4[mCounter] = Turbine.UI.Control();
			cjMenuIcon4[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon4[mCounter]:SetHeight(iconSize);
			cjMenuIcon4[mCounter]:SetWidth(iconSize);
			cjMenuIcon4[mCounter]:SetLeft(icon4Left);
			cjMenuIcon4[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			cjMenuIcon4[mCounter]:SetBackground(cjThumbDir .. cjCol[4]);
			cjMenuIcon4[mCounter]:SetMouseVisible(false);
		end

		if cjCol[5] ~= "Blank.tga" then
			cjMenuIcon5[mCounter] = Turbine.UI.Control();
			cjMenuIcon5[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon5[mCounter]:SetHeight(iconSize);
			cjMenuIcon5[mCounter]:SetWidth(iconSize);
			cjMenuIcon5[mCounter]:SetLeft(icon5Left);
			cjMenuIcon5[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			cjMenuIcon5[mCounter]:SetBackground(cjThumbDir .. cjCol[5]);
			cjMenuIcon5[mCounter]:SetMouseVisible(false);
		end

		if cjCol[6] ~= "Blank.tga" then
			cjMenuIcon6[mCounter] = Turbine.UI.Control();
			cjMenuIcon6[mCounter]:SetParent(cjMenuItem[mCounter]);
			cjMenuIcon6[mCounter]:SetHeight(iconSize);
			cjMenuIcon6[mCounter]:SetWidth(iconSize);
			cjMenuIcon6[mCounter]:SetLeft(icon6Left);
			cjMenuIcon6[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
			cjMenuIcon6[mCounter]:SetBackground(cjThumbDir .. cjCol[6]);
			cjMenuIcon6[mCounter]:SetMouseVisible(false);
		end

		cjMenuLabel[mCounter] = Turbine.UI.Label();
		cjMenuLabel[mCounter]:SetParent(cjMenuItem[mCounter]);
		cjMenuLabel[mCounter]:SetHeight(iconSize);
		cjMenuLabel[mCounter]:SetLeft(labelLeft);
		cjMenuLabel[mCounter]:SetTop((lineHeight / 2) - (iconSize / 2));
		cjMenuLabel[mCounter]:SetWidth(cjMenuItem[mCounter]:GetWidth() - labelLeft - 1)
		cjMenuLabel[mCounter]:SetText(gName);
		cjMenuLabel[mCounter]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		cjMenuLabel[mCounter]:SetMultiline(false);
		cjMenuLabel[mCounter]:SetMouseVisible(false);

-- Mouse events and focus events
		cjMenuItem[mCounter].MouseEnter = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.6, 0.0, 0.3, 0.3));
			cjTTip:SetText( gName );
			cjTTip:SetVisible(true);
			cjTTText1:SetText( gTip1 );
			cjTTText2:SetText( gTip2 );
			cjTTText3:SetText( gTip3 );
			cjTTText4:SetText( gTip4 );
			cjTTText5:SetText( gTip5 );
		end

		cjMenuItem[mCounter].MouseLeave = function(sender, args)
			sender:SetBackColor(Turbine.UI.Color(0.6, 0.3, 0.3, 0.2));
			-- cjTTip:SetVisible(false);
		end

		cjMenuItem[mCounter].MouseClick = function(sender, args)
		local Children = sender:GetControls();
		local cCount = Children:GetCount();
		local label = Children:Get(cCount);
		local selItem = label:GetText();

		local y = 1;
		while y <= NumCJs do
			local selName = cjSets[y].Name;
			if selName == selItem then
				setBarShortcuts(y);
				break
			else
				y = y + 1;
			end
		end

		cjMenuParent:SetVisible(false); -- Hide menu after click.
		cjTTip:SetVisible(false);
		end

		-- Click outside menu, close window.
		cjMenuParent.MouseClick = function(sender, args)
			cjMenuParent:SetVisible(false);
			cjTTip:SetVisible(false);

		end

-- Increments
		menuCurTop = menuCurTop + lineHeight + linebuffer;

		mCounter = mCounter + 1;
		menuCurHeight = menuCurTop;

		if menuCurHeight > menuMaxHeight then
-- Do not make menu larger, instead add a scrollbar.
			cjMenuBody:SetHeight(menuMaxHeight);
			cjMenuBody:SetWidth(menuWidth + 16);
			cjMenuHolder:SetHeight(menuCurHeight);
			scrollBar:SetLeft(menuWidth);
			scrollBar:SetMaximum(menuCurHeight - menuMaxHeight);
			scrollBar:SetHeight(menuMaxHeight);
			scrollIncBut:SetTop(scrollBar:GetHeight()-15);
			scrollDecBut:SetTop(0);
			scrollThumb:SetTop(15);
			scrollBar:SetVisible(true);

			local visiblePercent = menuMaxHeight / menuCurHeight;
			local thumbSize = (menuMaxHeight * visiblePercent) - 30;

			scrollThumb:SetHeight(thumbSize);
			scrollThumb:SetStretchMode(3);

			scrollBar:SetSmallChange(10);
			scrollBar:SetLargeChange(20);

			scrollBar.ValueChanged = function(sender, args)
-- Move the Holder Window up/down depending on bar value.
			local thumbValue = scrollBar:GetValue();
			local holderTop = -(thumbValue);

			cjMenuHolder:SetTop(holderTop);
			end

		else
			cjMenuBody:SetHeight(menuCurHeight);
			cjMenuBody:SetWidth(menuWidth);
			cjMenuHolder:SetHeight(menuCurHeight);
			scrollBar:SetVisible(false);
		end
		i = i + 1
		else
			i = i + 1;
		end
	end
end

-- Display the menu at the current mouse position, but not off-screen.
function displayMenu()

	local initX = Turbine.UI.Display.GetMouseX();
	local initY = Turbine.UI.Display.GetMouseY();
	local screenHeight = Turbine.UI.Display.GetHeight();
	local screenWidth = Turbine.UI.Display.GetWidth();
	local menuHeight = cjMenuBody:GetHeight();
	local menuWidth = cjMenuBody:GetWidth();

	if (initX + menuWidth) > screenWidth then
-- Menu will appear off-screen to the left, so load it to the right of the mouse location.
		cjMenuBody:SetLeft(initX - menuWidth);
	else
		cjMenuBody:SetLeft(initX);
	end

	if (initY + menuHeight) > (screenHeight - 75) then
-- Menu will appear off-screen to the bottom, so load it to touch the bottom of the screen.
		cjMenuBody:SetTop(screenHeight - menuHeight - 75);
	else
		cjMenuBody:SetTop(initY);
	end

	scrollBar:SetValue(0);
	cjMenuHolder:SetTop(0);

	cjMenuParent:SetVisible(true);

end
